<template>
  <div v-if="loaded" class="d-flex justify-center align-center container">
    <v-progress-circular
      :size="50"
      color="amber"
      indeterminate
    ></v-progress-circular>

    <v-dialog
      v-model="dialog"
      transition="dialog-top-transition"
      max-width="400px"
      persistent
    >
      <template v-slot:default>
        <v-card rounded="xl">
          <v-form @submit.prevent="onUpdate">
            <v-toolbar
              color="#fcc200"
              title="ข้อมูลส่วนตัว"
              class="align-text-center"
            />
            <v-card-text class="pb-0 px-6">
              <v-text-field
                variant="outlined"
                density="compact"
                rounded="xl"
                label="ชื่อผู้ใช้"
                v-model="userName"
              ></v-text-field><br>
              <v-select
                v-model="department"
                :items="departments"
                :rules="[depRules.required]"
                label="สาขา"
                variant="outlined"
                rounded="xl"
                density="compact"
                item-title="attributes.name"
                item-value="id"
                class="mb-1"
              ></v-select>
              <v-text-field
                v-model="studentId"
                :rules="[sidRules.required, sidRules.format]"
                variant="outlined"
                density="compact"
                rounded="xl"
                label="รหัสนักศึกษา"
              ></v-text-field><br>
              <v-select
                v-model="preFix"
                :items="['นาย', 'นางสาว']"
                :rules="[prefixRules.required]"
                label="คำนำหน้า"
                variant="outlined"
                rounded="xl"
                density="compact"
                item-title="attributes.name"
                item-value="id"
                class="mb-1"
              >
                <template v-slot:item="{ props }">
                  <v-list-item v-bind="props" rounded="xl"></v-list-item>
                </template>
              </v-select>
              <v-text-field
                v-model="firstName"
                :rules="[firstnameRules.required]"
                variant="outlined"
                density="compact"
                rounded="xl"
                label="ชื่อ"
                class="mb-1"
              ></v-text-field>
              <v-text-field
                v-model="lastName"
                :rules="[lastnameRules.required]"
                variant="outlined"
                density="compact"
                rounded="xl"
                label="สกุล"
                class="mb-1"
              ></v-text-field>
              <v-text-field
                v-model="phoneNumber"
                :rules="[phonenumberRules.required]"
                variant="outlined"
                density="compact"
                rounded="xl"
                label="เบอร์โทรศัพท์"
                type="number"
                :counter="10"
              ></v-text-field>
            </v-card-text>

            <v-card-actions class="justify-space-evenly pt-0 mt-2">
              <v-btn
                :loading="loadingbtn"
                :disabled="!isFormValid"
                variant="text"
                type="submit"
                color="amber-darken-1"
                rounded="xl"
              >ยืนยัน</v-btn>
            </v-card-actions>
          </v-form>
        </v-card>
      </template>
    </v-dialog>
  </div>
</template>

<script setup>
useHead({
  title: "ระบบยืม-คืน | เข้าสู่ระบบด้วย Google",
  meta: [{ name: "description", content: "เข้าสู่ระบบด้วย Google" }],
});

definePageMeta({
  layout: false,
});

import { ref, onMounted } from "vue";
import axios from "axios";

const { authenticateProvider } = useStrapiAuth();
const route = useRoute()
const router = useRouter()
const url = useStrapiUrl()

const jwt = ref()
const departments = ref()

const userId = ref()
const userName = ref()
const preFix = ref()
const firstName = ref()
const lastName = ref()
const phoneNumber = ref("")
const studentId = ref()
const department = ref()

const dialog = ref(false)
const loaded = ref(false)
const loadingbtn = ref(false)

const depRules = {
  required: (value) => !!value || "กรุณาเลือกสาขาวิชา",
};
const sidRules = {
  required: (value) => !!value || "กรุณากรอกรหัสนักศึกษา",
  format: (value) => {
    const pattern = /^\d{11,}-\d$/;
    return pattern.test(value) || "รูปแบบไม่ถูกต้อง เช่น xxxxxxxxxxx-x";
  },
};
const prefixRules = {
  required: (value) => !!value || "กรุณาเลือกคำนำหน้า",
};
const firstnameRules = {
  required: (value) => !!value || "กรุณากรอกชื่อ",
};
const lastnameRules = {
  required: (value) => !!value || "กรุณากรอกนามสกุล",
};
const phonenumberRules = {
  required: (value) => !!value || "กรุณากรอกเบอร์โทรศัพท์มือถือ",
};

const isphonenumberValid = (value) =>
    value && value.startsWith("0") && value.length === 10 && !isNaN(value);
const isstudentidValid = (value) => {
  // เช็คว่ามี "-" และตัวเลขลงท้ายหรือไม่
  const pattern = /^\d+-\d$/;
  return pattern.test(value) && value.length >= 13;
};

const isFormValid = computed(() => {
  return (
      !!userName.value &&
      !!department.value &&
      !!studentId.value &&
      !!preFix.value &&
      !!firstName.value &&
      !!lastName.value &&
      !!phoneNumber.value &&
      isstudentidValid(studentId.value) &&
      isphonenumberValid(phoneNumber.value)
  );
});

async function onUpdate() {
  loadingbtn.value = true;
  await setTimeout(() => (loadingbtn.value = false), 2000);
  
  try {
    await axios.put(`${url}/users/${userId.value}`, {
      prefix: preFix.value,
      username: userName.value,
      firstname: firstName.value,
      lastname: lastName.value,
      phone_number: phoneNumber.value,
      student_id: studentId.value,
      department: department.value
    }, {
      headers: {
        'Authorization': `Bearer ${jwt.value}`,
      },
    })
    
    console.log("Updated")
    await getUser();

  } catch (error) {
    console.error('เกิดข้อผิดพลาดในการอัปเดตข้อมูล:', error);
  }
};

async function getUser() {
  try {
    const response = await axios.get(`${url}/users/me`, {
      params: {
        fields: {
          1: "username",
          2: "email",
          3: "prefix",
          4: "firstname",
          5: "lastname",
          6: "student_id",
          7: "phone_number",
        },
        populate: {
          image: {
            fields: {
              8: "url",
            },
          },
          department: {
            fields: {
              9: "name",
            },
            populate: {
              faculty: {
                fields: {
                  10: "name",
                },
              },
            },
          },
        },
      },
      headers: {
        Authorization: `Bearer ${jwt.value}`,
      },
    });
    userId.value = response.data.id
    userName.value = response.data.username;

    if (
      !response.data.prefix ||
      !response.data.firstname ||
      !response.data.lastname ||
      !response.data.department ||
      !response.data.student_id ||
      !response.data.phone_number
    ) {
      console.log("Incomplete information");
      dialog.value = true;
      console.log("Dialog : ", dialog.value);
      getDepartments();
    } else {
      router.push("/")
    }
  } catch (error) {
    console.log(error);
  }
}

async function googleAuthenticate() {
  const google = await authenticateProvider(
    "google",
    route.query.access_token
  );
  jwt.value = google.jwt;
  getUser();
}

async function getDepartments() {
  await axios.get(`${url}/departments`).then((res) => {
    departments.value = [...res.data.data];
  });
}

onMounted(async () => {
  await googleAuthenticate();
  loaded.value = true;
});
</script>

<style scoped>
.container {
  height: 100vh;
}
</style>
